--edit hummel (modhoster.de)
moveAttacher = {};

function moveAttacher.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function moveAttacher:load(xmlFile)
	self.setzAttacher= SpecializationUtil.callSpecializationsFunction("setzAttacher");
	self.moveableAttacher = {};
	self.moveableAttacher.index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.moveableAttacher#index"));
	self.moveableAttacher.max = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableAttacher#maxZ"), 0); 
	self.moveableAttacher.min = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableAttacher#minZ"), 0); 
	
	if self.moveableAttacher ~= nil then
	
		local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableAttacher.index);
		self.zAttacher = zAttacher
	end;
	
end;

function moveAttacher:delete()
end;

function moveAttacher:mouseEvent(posX, posY, isDown, isUp, button)
end;

function moveAttacher:keyEvent(unicode, sym, modifier, isDown)

end;

function moveAttacher:update(dt)

	if self.moveableAttacher ~= nil then
	
		local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableAttacher.index);
		local maxZ = self.moveableAttacher.max;
		local minZ = self.moveableAttacher.min;
		local moveSpeed = 0.005;
		
			if InputBinding.isPressed(InputBinding.Saddle_FRONT) and self:getIsActiveForInput() then
					
				if self.zAttacher < maxZ then
					self.zAttacher = zAttacher + moveSpeed;
				else
					self.zAttacher = maxZ;
				end;
				   self:setzAttacher(self.zAttacher);
			elseif InputBinding.isPressed(InputBinding.Saddle_BACK) and self:getIsActiveForInput() then
				if self.zAttacher > minZ then
					self.zAttacher = zAttacher - moveSpeed;
				else
					self.zAttacher = minZ;
				end;
				   self:setzAttacher(self.zAttacher);
			end;
	end;
				
end;

function moveAttacher:setzAttacher(value, noEventSend)
  local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableAttacher.index);
  moveAttacherEvent.sendEvent(self, value, noEventSend);
  self.zAttacher = value
  
  setTranslation(self.moveableAttacher.index, xAttacher, yAttacher, self.zAttacher);
  
end

function moveAttacher:readStream(streamId, connection)


	self.zAttacher = streamReadFloat32(streamId);	

end;

function moveAttacher:writeStream(streamId, connection)

	streamWriteFloat32(streamId, self.zAttacher);

end;


function moveAttacher:onLeave()
	moveAttacherEvent.sendEvent(self, self.zAttacher);
end;

function moveAttacher:draw()
	g_currentMission:addExtraPrintText(string.format(g_i18n:getText("ATTACHER_CONTROLS"), self.typeDesc) .. " " .. InputBinding.getKeyNamesOfDigitalAction(InputBinding.Saddle_FRONT) .. "/" .. InputBinding.getKeyNamesOfDigitalAction(InputBinding.Saddle_BACK));

end;

function moveAttacher:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

moveAttacherEvent = {};
moveAttacherEvent_mt = Class(moveAttacherEvent, Event);

InitEventClass(moveAttacherEvent, "moveAttacherEvent");

function moveAttacherEvent:emptyNew()
    local self = Event:new(moveAttacherEvent_mt);
    self.className="moveAttacherEvent";
    return self;
end;

function moveAttacherEvent:new(object, data)
    local self = moveAttacherEvent:emptyNew()
    self.object = object;
	self.data = data;
    return self;
end;

function moveAttacherEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.object = networkGetObject(id);	
	self.data = streamReadFloat32(streamId);
	self:run(connection);
end;

function moveAttacherEvent:run(connection)
    self.object:setzAttacher(self.data , true);
    if not connection:getIsServer() then  
      g_server:broadcastEvent(moveAttacherEvent:new(self.object, self.data), nil, connection, self.object);
    end;
end;

function moveAttacherEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteFloat32(streamId, self.data);
end;

              
function moveAttacherEvent.sendEvent(vehicle, data, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(moveAttacherEvent:new(vehicle, data), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(moveAttacherEvent:new(vehicle, data));
		end;
	end
end;



